<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RequestRejected StructType
 * @subpackage Structs
 */
class RequestRejected extends AbstractStructBase
{
    /**
     * The RequestRejectedReason
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RequestRejectedReason[]
     */
    public $RequestRejectedReason;
    /**
     * Constructor method for RequestRejected
     * @uses RequestRejected::setRequestRejectedReason()
     * @param \StructType\RequestRejectedReason[] $requestRejectedReason
     */
    public function __construct(array $requestRejectedReason = array())
    {
        $this
            ->setRequestRejectedReason($requestRejectedReason);
    }
    /**
     * Get RequestRejectedReason value
     * @return \StructType\RequestRejectedReason[]|null
     */
    public function getRequestRejectedReason()
    {
        return $this->RequestRejectedReason;
    }
    /**
     * This method is responsible for validating the values passed to the setRequestRejectedReason method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRequestRejectedReason method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRequestRejectedReasonForArrayConstraintsFromSetRequestRejectedReason(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $requestRejectedRequestRejectedReasonItem) {
            // validation for constraint: itemType
            if (!$requestRejectedRequestRejectedReasonItem instanceof \StructType\RequestRejectedReason) {
                $invalidValues[] = is_object($requestRejectedRequestRejectedReasonItem) ? get_class($requestRejectedRequestRejectedReasonItem) : sprintf('%s(%s)', gettype($requestRejectedRequestRejectedReasonItem), var_export($requestRejectedRequestRejectedReasonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RequestRejectedReason property can only contain items of type \StructType\RequestRejectedReason, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RequestRejectedReason value
     * @throws \InvalidArgumentException
     * @param \StructType\RequestRejectedReason[] $requestRejectedReason
     * @return \StructType\RequestRejected
     */
    public function setRequestRejectedReason(array $requestRejectedReason = array())
    {
        // validation for constraint: array
        if ('' !== ($requestRejectedReasonArrayErrorMessage = self::validateRequestRejectedReasonForArrayConstraintsFromSetRequestRejectedReason($requestRejectedReason))) {
            throw new \InvalidArgumentException($requestRejectedReasonArrayErrorMessage, __LINE__);
        }
        $this->RequestRejectedReason = $requestRejectedReason;
        return $this;
    }
    /**
     * Add item to RequestRejectedReason value
     * @throws \InvalidArgumentException
     * @param \StructType\RequestRejectedReason $item
     * @return \StructType\RequestRejected
     */
    public function addToRequestRejectedReason(\StructType\RequestRejectedReason $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RequestRejectedReason) {
            throw new \InvalidArgumentException(sprintf('The RequestRejectedReason property can only contain items of type \StructType\RequestRejectedReason, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RequestRejectedReason[] = $item;
        return $this;
    }
}
